#pragma once // Do not change this line!
#ifdef STAMPS_V4X
// ------------------------------------- Leitura dos stamps
  void check_parametro_ph_aquario()
  {
    bool done = false;
    byte holding;
    char sensorstring[15];

    do
    {
      Open_channel(ph1);
      delay(50);
      #ifdef USE_FAHRENHEIT
        Serial1.print((tempC - 32) / 1.8);
      #else
        Serial1.print(tempC);
      #endif
      Serial1.print('\r');
      delay(500);

      if (Serial1.available() > 3)
      {
        holding = Serial1.available();
        for (byte i = 1; i <= holding; i++)
        {
          sensorstring[i] = Serial1.read();
        }

        if (holding == 5)
        {
          PHA = ((sensorstring[1] - 48) * 100 + (sensorstring[3] - 48) * 10 + (sensorstring[4] - 48));
          PHA /= 100;
        }
        else
        {
          PHA = ((sensorstring[1] - 48) * 1000 + (sensorstring[2] - 48) * 100 + (sensorstring[4] - 48) * 10 + (sensorstring[5] - 48));
          PHA /= 100;
        }
        Serial1.flush();
        break;
      }
    }
    while (done == true);
  }

  void check_parametro_ph_reator()
  {
    bool done = false;
    byte holding;
    char sensorstring[15];

    do
    {
      Open_channel(ph2);
      delay(50);
      #ifdef USE_FAHRENHEIT
        Serial1.print((tempC - 32) / 1.8);
      #else
        Serial1.print(tempC);
      #endif
      Serial1.print('\r');
      delay(500);

      if (Serial1.available() > 3)
      {
        holding = Serial1.available();
        for (byte i = 1; i <= holding; i++)
        {
          sensorstring[i] = Serial1.read();
        }
        if (holding == 5)
        {
          PHR = ((sensorstring[1] - 48) * 100 + (sensorstring[3] - 48) * 10 + (sensorstring[4] - 48));
          PHR /= 100;
        }
        else
        {
          PHR = ((sensorstring[1] - 48) * 1000 + (sensorstring[2] - 48) * 100 + (sensorstring[4] - 48) * 10 + (sensorstring[5] - 48));
          PHR /= 100;
        }
        Serial1.flush();
        break;
      }
    }
    while (done == true);
  }

  void check_parametro_orp()
  {
    bool done = false;
    byte holding;
    char sensorstring[15];

    do
    {
      Open_channel(orp);
      delay(50);
      Serial1.print("r"),
      Serial1.print('\r');
      delay(500);

      if (Serial1.available() > 3)
      {
        holding = Serial1.available();
        for (byte i = 1; i <= holding; i++)
        {
          sensorstring[i] = Serial1.read();
        }
        if (holding == 5)
        {
          ORP = ((sensorstring[1] - 48) * 10 + (sensorstring[2] - 48));
        }
        else
        {
          ORP = ((sensorstring[1] - 48) * 100 + (sensorstring[2] - 48) * 10 + (sensorstring[3] - 48));
        }
        Serial1.flush();
        break;
      }
    }
    while (done == true);
  }

  void check_parametro_densidade()
  {
    bool done = false;
    byte holding;
    char sensorstring[16];

    do
    {
      Open_channel(ec);
      delay(50);
      #ifdef USE_FAHRENHEIT
        Serial1.print((tempC - 32) / 1.8);
      #else
        Serial1.print(tempC);
      #endif
      Serial1.print('\r');
      delay(500);
      if (Serial1.available() > 3)
      {
        holding = Serial1.available();
        for (byte i = 1; i <= 15; i++)
        {
          sensorstring[i] = Serial1.read();
        }

        if (holding == 5)
        {
          DEN = ((sensorstring[1] - 48) * 1000 + (sensorstring[3] - 48) * 100 + (sensorstring[4] - 48 * 10) + (sensorstring[5] - 48));
        }
        Serial1.flush();
        break;
      }
    }
    while (done == true);
  }

  void iniciar_stamp_ph_aquario()
  {
    Open_channel(ph1);
    delay(50);
    Serial1.print("e"); // Envia um comando para que o "stamp" pare de enviar as leituras.
    Serial1.print('\r');
    delay(1000);
    Serial1.flush();
    Serial1.print("L0"); // Envia um comando para que o "stamp" apague o led de depuração.
    Serial1.print('\r');
    delay(1000);
    check_parametro_ph_aquario();
  }

  void iniciar_stamp_ph_reator()
  {
    Open_channel(ph2);
    delay(50);
    Serial1.print("e"); // Envia um comando para que o "stamp" pare de enviar as leituras.
    Serial1.print('\r');
    delay(1000);
    Serial1.flush();
    Serial1.print("L0"); // Envia um comando para que o "stamp" apague o led de depuração.
    Serial1.print('\r');
    delay(1000);
    check_parametro_ph_reator();
  }

  void iniciar_stamp_orp()
  {
    Open_channel(orp);
    delay(50);
    Serial1.print("e"); // Envia um comando para que o "stamp" pare de enviar as leituras.
    Serial1.print('\r');
    delay(1000);
    Serial1.flush();
    Serial1.print("L0"); // Envia um comando para que o "stamp" apague o led de depuração.
    Serial1.print('\r');
    delay(1000);
    check_parametro_orp();
  }

  void iniciar_stamp_densidade()
  {
    Open_channel(ec);
    delay(50);
    Serial1.print("e"); // Envia um comando para que o "stamp" pare de enviar as leituras.
    Serial1.print('\r');
    delay(1000);
    Serial1.flush();
    Serial1.print("L0"); // Envia um comando para que o "stamp" apague o led de depuração.
    Serial1.print('\r');
    delay(1000);
    check_parametro_densidade();
  }

  void Open_channel(short channel)
  {
    switch (channel)
    {
      case 0:
        // open channel Y0
        // S0=0
        // S1=0
        digitalWrite(multiplexadorS0Pin, LOW);
        digitalWrite(multiplexadorS1Pin, LOW);
        break;

      case 1:
        // open channel Y1
        // S0=1
        // S1=0
        digitalWrite(multiplexadorS0Pin, HIGH);
        digitalWrite(multiplexadorS1Pin, LOW);
        break;

      case 2:
        // open channel Y2
        // S0=0
        // S1=1
        digitalWrite(multiplexadorS0Pin, LOW);
        digitalWrite(multiplexadorS1Pin, HIGH);
        break;

      case 3:
        // open channel Y3
        // S0=1
        // S1=1
        digitalWrite(multiplexadorS0Pin, HIGH);
        digitalWrite(multiplexadorS1Pin, HIGH);
        break;
    }
    Serial1.print('\r');
    return;
  }
#endif
